%%%---------------------------------------------------------------------%%%
%%%-------------------Function for "Willhiteeexample"-------------------%%%
%%%------------------------Last updated 11.05.15------------------------%%%
%%%---------------------------------------------------------------------%%%

%The function is used for an iterative solution to determine a proper
%combination of U_to and T_ci.

function [U_to_new, T_wb] = Uwillhite(U_temp,r_wb,t,alpha,T_f,k_e,r_to,...
    T_geo,r_co,k_cem,e_to,r_ci,e_ci,SB,cp_an,my_an,k_ha,rho_an,g)

f_t=log(2*sqrt(alpha*t)/r_wb)-0.29;

run_while=5;
Counter=0;

while run_while>4;
    Counter=Counter+1;
    T_wb=(T_f*f_t+(k_e/(r_to*U_temp)*T_geo))/(f_t+(k_e/(r_to*U_temp)));
    T_ci=T_wb+(r_to*U_temp*log(r_wb/r_co))/k_cem*(T_f-T_wb);

    F_tci=1/((1/e_to)+((r_to/r_ci)*(1/e_ci-1)));
    %Temperatures i Rankin (T(R)=T(F)+460)
    h_r=SB*F_tci*((T_f+460).^2+(T_ci+460).^2)*((T_f+460)+(T_ci+460)); 

    T_an=(T_f+T_ci)/2;      %Temp in Annulus, F
    betta=1/(T_an+460);     %Temp in R
    %Prandtl number, Pr
    Pr=(cp_an*my_an)/k_ha; 
    %Grashof number, Gr
    Gr=((r_ci-r_to).^3*g*rho_an.^2*betta*(T_f-T_ci))/my_an.^2;  
    h_c=((0.049*(Gr*Pr).^(1/3))*(Pr.^0.074)*k_ha)/(r_to*log(r_ci/r_to));
    
    %Overall heat transfer coefficient, Btu/hr sq ft F
    U_to_new=(1/(h_c+h_r)+(r_to*log(r_wb/r_co))/k_cem).^-1;
    
    %Margin of error in the iterative approach 
    if abs(U_to_new-U_temp)<1e-10
        break
    else
        U_temp=U_to_new;
    end
    
end
disp(['Counter:' num2str(Counter)]);
end








